--  James Dean Palmer's JCGI (08.17.98)
--  A free CGI module by James Dean Palmer.
--
--  The CGI class provides a number of HTML utility functions for
--  building interactive CGI applications.  It is some what
--  inspired by the perl CGI module by L. Stein.
--
--  This code works but is not complete.  I will complete a "1.0"
--  version of JCGI by the middle of September '98.

class CGI

creation make

feature
   bgcolor: STRING;         -- Page back ground color.
   text: STRING;            -- Default text color.
   link: STRING;            -- Default link color.
   vlink: STRING;           -- Default visited link color.
   alink: STRING;           -- Default activated link color.
   pretty: BOOLEAN;         -- Space formating on/off.
   remote_host: STRING;
   http_referer: STRING;
   http_user_agent: STRING;

feature {NONE}
   parameters: STRING;      -- Passed parameters.
   key: ARRAY[STRING];
   value: ARRAY[STRING];
   jio: STD_INPUT;
   env: GENERAL;

feature
   make is
      do
	 !!bgcolor.make(0);
	 !!text.make(0);
	 !!link.make(0);
	 !!vlink.make(0);
	 !!alink.make(0);
	 !!parameters.make(0);
	 !!remote_host.make(0);
	 !!http_referer.make(0);
	 !!http_user_agent.make(0);
	 !!env;
	 !!key.make(0,-1);
	 !!value.make(0,-1);

	 if (not (env.get_environment_variable("QUERY_STRING") = Void)) then
	    parameters.copy(env.get_environment_variable("QUERY_STRING"));
	    parameters.append("&");
	    parse;
	 else
	    parameters.copy("");
	 end;

	 if (not (env.get_environment_variable("REMOTE_HOST") = Void)) then
	    remote_host.copy(env.get_environment_variable("REMOTE_HOST"));
	 else
	    remote_host := Void;
	 end;

	 if (not (env.get_environment_variable("HTTP_REFERER") = Void)) then
	    http_referer.copy(env.get_environment_variable("REMOTE_HOST"));
	 else
	    http_referer := Void;
	 end;

	 if (not (env.get_environment_variable("HTTP_USER_AGENT") = Void)) then
	    http_user_agent.copy(env.get_environment_variable("HTTP_USER_AGENT"));
	 else
	    http_user_agent := Void;
	 end;

--	 !!key.make(1);
--	 !!value.make(1);
--	 from
--	    !!jio.make;
--	 until
--	    jio.end_of_input = true
--	 loop
--	    jio.read_character;
--	    parameters.add_last(jio.last_character);
--	 end;
--	 io.put_string(parameters);
      end;

feature
   header(s: STRING):STRING is
      do
	 s.copy(indent(s));
	 s.prepend("<head>%N");
	 s.prepend("Content-type: text/html%N%N<!DOCTYPE HTML PUBLIC %"-//IETF//DTD HTML//EN%">%N<html>%N");
	 s.append("%N</head>%N");
	 Result := s;
      end;

feature
   tail:STRING is
      do
	 Result := "%N</html>%N";
      end;
   
feature
   title(s: STRING):STRING is
      do
	 s.copy(indent(s));
	 s.prepend("<title>%N");
	 s.append("%N</title>");
	 Result := s;
      end;

feature
   body(s: STRING):STRING is
      do
	 s.copy(indent(s));
	 s.prepend(">%N");
	 if (bgcolor.count > 0) then
	    s.prepend("%"");
	    s.prepend(bgcolor);
	    s.prepend(" bgcolor=%"");
	 end;
	 if (text.count > 0) then
	    s.prepend("%"");
	    s.prepend(text);
	    s.prepend(" text=%"");
	 end;
	 if (link.count > 0) then
	    s.prepend("%"");
	    s.prepend(link);
	    s.prepend(" link=%"");
	 end;
	 if (vlink.count > 0) then
	    s.prepend("%"");
	    s.prepend(vlink);
	    s.prepend(" vlink=%"");
	 end;
	 if (alink.count > 0) then
	    s.prepend("%"");
	    s.prepend(alink);
	    s.prepend(" alink=%"");
	 end;
	 s.prepend("<body");
	 s.append("%N</body>");
	 Result := s;
      end;
   
feature 
   bold(s: STRING):STRING is
      do
	 s.prepend( "<b>");
	 s.append("</b>");
	 Result := s;
      end;

feature 
   italics(s: STRING):STRING is
      do
	 s.prepend( "<i>");
	 s.append("</i>");
	 Result := s;
      end;

feature 
   emphasis(s: STRING):STRING is
      do
	 s.prepend( "<em>");
	 s.append("</em>");
	 Result := s;
      end;

feature 
   heading(s: STRING; i: INTEGER):STRING is
      require i>0;
      do
	 s.copy(indent(s));
	 s.prepend(">%N");
	 s.prepend(i.to_string);
	 s.prepend( "%N<h");
	 s.append("%N</h");
	 s.append(i.to_string);
	 s.append(">");
	 Result := s;
      end;

feature 
   ahref(s: STRING; t:STRING):STRING is
      do
	 s.prepend("<a href=%"");
	 s.append("%">");
	 s.append(t);
	 s.append("</a>");
	 Result := s;
      end;

feature
   table(s:STRING):STRING is
      do
	 s.copy(indent(s));
	 s.prepend( "%N<table>%N");
	 s.append("%N</table>");
	 Result := s;
      end;

feature
   row(s:STRING):STRING is
      do
	 s.copy(indent(s));
	 s.prepend( "%N<tr>%N");
	 s.append("%N</tr>");
	 Result := s;
      end;

feature
   column(s:STRING):STRING is
      do
	 s.copy(indent(s));
	 s.prepend( "%N<th>%N");
	 s.append("%N</th>");
	 Result := s;
      end;

feature
   startform(method: STRING; action: STRING; encoding: STRING):STRING is
      do
	 Result := "<form action=%"";
	 Result.append(action);
	 Result.append("%" method=%"");
	 Result.append(method);
	 Result.append("%" encoding=%"");
	 Result.append(encoding);
	 Result.append("%">");
      end;

feature
   textfield(name: STRING; dtext: STRING; size: INTEGER; length: INTEGER): STRING is
      do
	 Result := name;
	 Result.prepend("<input type=%"text%" name=%"");
	 Result.append("%" value=%"");
	 Result.append(dtext);
	 Result.append("%"");
	 if (size>0) then
	    Result.append(" size=");
	    Result.append(size.to_string);
	 end;
	 if (length>0) then
	    Result.append(" maxlength=");
	    Result.append(length.to_string);
	 end;
	 Result.append(">");
      end;

feature
   passwordfield(name: STRING; dtext: STRING; size: INTEGER; length: INTEGER): STRING is
      do
	 Result := name;
	 Result.prepend("<input type=%"password%" name=%"");
	 Result.append("%" value=%"");
	 Result.append(dtext);
	 Result.append("%"");
	 if (size>0) then
	    Result.append(" size=");
	    Result.append(size.to_string);
	 end;
	 if (length>0) then
	    Result.append(" maxlength=");
	    Result.append(length.to_string);
	 end;
	 Result.append(">");
      end;

feature
   checkbox(name: STRING; dtext: STRING; checked: BOOLEAN): STRING is
      do
	 Result := name;
	 Result.prepend("<input type=%"checkbox%" name=%"");
	 Result.append("%" value=%"");
	 Result.append(dtext);
	 Result.append("%"");
	 if (checked) then
	    Result.append(" checked>");
	 else
	    Result.append(">");
	 end;
      end;

feature
   radio(name: STRING; dtext: STRING; checked: BOOLEAN): STRING is
      do
	 Result := name;
	 Result.prepend("<input type=%"radio%" name=%"");
	 Result.append("%" value=%"");
	 Result.append(dtext);
	 Result.append("%"");
	 if (checked) then
	    Result.append(" checked>");
	 else
	    Result.append(">");
	 end;
      end;

feature
   selectlist(name: STRING; size: INTEGER; multiple: BOOLEAN; dtext: STRING): STRING is
      do
	 Result := name;
	 Result.prepend("<select name=%"");
	 if (size>0) then
	    Result.append("%" size=");
	    Result.append(size);
	 else 
	    Result.append("%"");
	 end;
	 if (multiple) then
	    Result.append(" multiple>");
	 else
	    Result.append(">");
	 end;
	 Result.append(dtext);
	 Result.append("</select>");
      end;

feature
   option(name: STRING; selected: BOOLEAN):STRING is
      do
	 Result := name;
	 if (selected) then
	    Result.prepend(" selected>");
	 else
	    Result.prepend(">");
	 end;
	 Result.prepend("<option");
      end;

feature
   textarea(name: STRING; dtext: STRING; rows: INTEGER; columns: INTEGER): STRING is
      do
	 Result := name;
	 Result.prepend("<textarea name=%"");
	 Result.append("%" rows=");
	 Result.append(rows.to_string);
	 Result.append("cols=");
	 Result.append(columns.to_string);
	 Result.append(">");
	 Result.append(dtext);
	 Result.append("</textarea>");
      end;

feature
   endform: STRING is
      do
	 Result := "</form>";
      end;

feature 
   paragraph(s: STRING):STRING is
      do
	 s.copy(indent(s));
	 s.prepend( "%N<p>%N");
	 s.append("%N</p>");
	 Result := s;
      end;

feature 
   hr(s: STRING):STRING is
      do
	 s.prepend( "<hr>%N");
	 Result := s;
      end;

feature 
   br(s: STRING):STRING is
      do
	 s.prepend( "<br>%N");
	 Result := s;
      end;

feature
   level(s: ARRAY[STRING]):STRING is
      local
	 i: INTEGER;
      do
	 !!Result.make(1);
	 from 
	    i := s.lower;
	 until
	    i > s.upper
	 loop
	    Result.append(s.item(i));
	    i := i + 1;
	 end;
      end;
   
feature
   indent(s: STRING):STRING is
      local
	 i: INTEGER;
      do
	 s.prepend("  ");
	 
	 from
	    i := 1;
	 until
	    i = s.count
	 loop
	    if (s.item(i) = '%N') then
	       s.insert(' ', i);
	       s.insert(' ', i);
	    end;
	    i := i + 1;
	 end;
	 Result := s;
      end;

feature
   parse is
      local
	 i : INTEGER;
	 jequal : INTEGER;
	 jand : INTEGER;
      do
	 jequal := 0;            -- Position of =
	 jand := 0;             -- Position of &

	 from
	    i := 1;
	 until
	    i > parameters.count
	 loop
	    if (parameters.item(i) = '&') then
	       key.add_last( parameters.substring(jand + 1, jequal - 1) );
	       if ((jequal + 1) > (i - 1)) then
		  value.add_last( Void );
	       else
		  value.add_last( parameters.substring(jequal + 1, i - 1) );
	       end;
	       jand := i;
	    end;
	    if (parameters.item(i) = '=') then
	       jequal := i;
	    end;
	    i := i + 1;
	 end;
      end;

feature
   param(s: STRING): ARRAY[STRING] is
      local
	 i: INTEGER;
      do
	 !!Result.make(0,-1);
	 from 
	    i := key.lower;
	 until
	    i > key.upper
	 loop
	    if (key.item(i) /= Void) then
	       if (key.item(i).compare(s) = 0) then
		  Result.add_last(value.item(i));
	       end;
	    end;
	    i := i + 1;
	 end;
      end;

feature
   escape(s:STRING): STRING is
      do
      end;

feature
   unescape(s:STRING): STRING is
      local
	 tmp: CHARACTER;
	 i: INTEGER;
      do
--        $postinput =~ s/\+/ /g;
--        $postinput =~ s/%([\da-f]{1,2})/pack(C,hex($1))/eig; 
	 from
	    i := 1;
	 until
	    i > s.upper
	 loop
	    if (s.item(i) = '+') then
	       s.put(' ', i);
	    end;
	    if ( (s.item(i) = '%%') and ( (i+2) <= s.upper) ) then
	       tmp := hextochar(s.substring(i+1, i+2));
	       i := i + 1;
	    end;
	 end;
      end;

feature
   hextochar (s: STRING): CHARACTER is
      local
	 i: INTEGER;
	 j: INTEGER;
      do
	 s.item(0).to_lower.code
	 j := 0;
	 from
	    i := 1;
	 until
	    i = 2
	 loop
	    j := j * 16;
	    if (s.item(i) = 'f') then 
	       j := j + (15);
	    else if (s.item(i) = 'e') then
	       j := j + (14);
	    else if (s.item(i) = 'd') then
	       j := j + (13);
	    else if (s.item(i) = 'c') then
	       j := j + (12);
	    else if (s.item(i) = 'b') then
	       j := j + (11);
	    else if (s.item(i) = 'a') then
	       j := j + (10);
	    else j := s.item(i).to_integer;
	    end; end; end; end; end; end;
	    i := i + 1;
	    Result := j.to_character;
	 end;
      end;

end -- CGI

